import { type Dispatch, type MutableRefObject, type SetStateAction } from 'react';
import type { VirtualElement } from '@floating-ui/core';
import type { DetectOverflowOptions, Middleware } from '@floating-ui/dom';
import type { Options as OffsetOptions } from '@floating-ui/core/src/middleware/offset';
import type { Options as ShiftOptions } from '@floating-ui/core/src/middleware/shift';
import type { Options as FlipOptions } from '@floating-ui/core/src/middleware/flip';
import type { Options as AutoPlacementOptions } from '@floating-ui/core/src/middleware/autoPlacement';
import type { Options as HideOptions } from '@floating-ui/core/src/middleware/hide';
import { type ExtendedRefs } from '@floating-ui/react';
export declare function useFloatingMiddlewareFromProps(setMiddleware: Dispatch<SetStateAction<Middleware[] | undefined>>, refs: ExtendedRefs<HTMLElement>, arrowRef: MutableRefObject<HTMLElement | null>, props: {
    offset?: OffsetOptions;
    shift?: boolean | number | Partial<ShiftOptions & DetectOverflowOptions>;
    flip?: boolean | number | Partial<FlipOptions & DetectOverflowOptions>;
    arrow?: boolean | number;
    autoPlacement?: boolean | Partial<AutoPlacementOptions & DetectOverflowOptions>;
    hide?: boolean | Partial<HideOptions & DetectOverflowOptions>;
    middleware?: Middleware[] | ((refs: {
        referenceEl: MutableRefObject<Element | VirtualElement | null>;
        floatingEl: MutableRefObject<HTMLElement | null>;
    }) => Middleware[]);
}): void;
